package turgen.plugin.standard;

import java.awt.CardLayout;
import java.awt.Component;
import javax.swing.*;
import java.io.*;
import turgen.Utils;
import turgen.dtb.DOS2Binary;
import turgen.plugin.InOutProvider;

public class StandardPluginPanel extends javax.swing.JPanel {
    
    private InOutProvider ioProvider;
    private final StandardPlugin plugin;
    
    /** Creates new PlTurboROMPluginPanel 
     * 
     * @param plugin Standard plugin
     */
    public StandardPluginPanel(StandardPlugin plugin) {
        initComponents();
        setupToolTips();
        onInputTypeChanged(null);
        this.plugin=plugin;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        bgGaps = new javax.swing.ButtonGroup();
        bgBasic = new javax.swing.ButtonGroup();
        pHeader = new javax.swing.JPanel();
        jtfName = new javax.swing.JTextField();
        jlbName = new javax.swing.JLabel();
        btnGuessHeader = new javax.swing.JButton();
        pHandling = new javax.swing.JPanel();
        jcoInputType = new javax.swing.JComboBox();
        btnCheckLoader = new javax.swing.JButton();
        pBinaryFile = new javax.swing.JPanel();
        jlbPauses = new javax.swing.JLabel();
        pSilenceList = new turgen.plugin.SilenceListPanel();
        pFiller = new javax.swing.JPanel();
        pOptions = new javax.swing.JPanel();
        pPlainOptions = new javax.swing.JPanel();
        jrbShortGaps = new javax.swing.JRadioButton();
        jrbLongGaps = new javax.swing.JRadioButton();
        pBASICOptions = new javax.swing.JPanel();
        jrbCLOAD = new javax.swing.JRadioButton();
        jrbLOAD = new javax.swing.JRadioButton();
        jrbBootable = new javax.swing.JRadioButton();
        pNoOptions = new javax.swing.JPanel();

        setLayout(new java.awt.GridBagLayout());

        pHeader.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Header"));
        pHeader.setLayout(new java.awt.GridBagLayout());

        jtfName.setColumns(22);
        jtfName.setFont(new java.awt.Font("Monospaced", 0, 12)); // NOI18N
        jtfName.setToolTipText("File name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        pHeader.add(jtfName, gridBagConstraints);

        jlbName.setText("File name:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        pHeader.add(jlbName, gridBagConstraints);

        btnGuessHeader.setMnemonic('h');
        btnGuessHeader.setText("Auto set header");
        btnGuessHeader.setToolTipText("<HTML>\nAutomatically fill the turbo header using:<BR>\n1.Analysis of input file<BR>\n2.Selected conversion type<BR>\n</HTML>\n\n");
        btnGuessHeader.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                on_guess_header(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        pHeader.add(btnGuessHeader, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(pHeader, gridBagConstraints);

        pHandling.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Input file type"));
        pHandling.setLayout(new java.awt.GridBagLayout());

        jcoInputType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Monolithic binary file", "Binary file", "Data file", "BASIC tokenized", "BASIC source" }));
        jcoInputType.setToolTipText("Choose type of the input file");
        jcoInputType.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                onInputTypeChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 0);
        pHandling.add(jcoInputType, gridBagConstraints);

        btnCheckLoader.setMnemonic('c');
        btnCheckLoader.setText("Check loader");
        btnCheckLoader.setEnabled(false);
        btnCheckLoader.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCheckLoaderActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        pHandling.add(btnCheckLoader, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(pHandling, gridBagConstraints);

        pBinaryFile.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Binary file"));
        pBinaryFile.setLayout(new java.awt.GridBagLayout());

        jlbPauses.setText("Silence list:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        pBinaryFile.add(jlbPauses, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 4);
        pBinaryFile.add(pSilenceList, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        add(pBinaryFile, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weighty = 1.0;
        add(pFiller, gridBagConstraints);

        pOptions.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Options"));
        pOptions.setLayout(new java.awt.CardLayout());

        pPlainOptions.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        bgGaps.add(jrbShortGaps);
        jrbShortGaps.setSelected(true);
        jrbShortGaps.setText("Short IRGs");
        jrbShortGaps.setToolTipText("Short (250 ms) IRGs");
        pPlainOptions.add(jrbShortGaps);

        bgGaps.add(jrbLongGaps);
        jrbLongGaps.setText("Long IRGs");
        jrbLongGaps.setToolTipText("Short (3 s) IRGs");
        pPlainOptions.add(jrbLongGaps);

        pOptions.add(pPlainOptions, "cPlain");

        pBASICOptions.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        bgBasic.add(jrbCLOAD);
        jrbCLOAD.setSelected(true);
        jrbCLOAD.setText("CLOAD");
        jrbCLOAD.setToolTipText("Convert to format loadable by the CLOAD command");
        pBASICOptions.add(jrbCLOAD);

        bgBasic.add(jrbLOAD);
        jrbLOAD.setText("LOAD\"C:\"");
        jrbLOAD.setToolTipText("Convert to format loadable by the LOAD\"C:\" or RUN\"C:\" commands");
        pBASICOptions.add(jrbLOAD);

        bgBasic.add(jrbBootable);
        jrbBootable.setText("Bootable");
        jrbBootable.setToolTipText("Convert to bootable format");
        pBASICOptions.add(jrbBootable);

        pOptions.add(pBASICOptions, "cBASIC");

        pNoOptions.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
        pOptions.add(pNoOptions, "cNone");

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        add(pOptions, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents
    
    private void on_guess_header(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_on_guess_header

        /*What conversion type was selected*/
        int inputType = comboIndex2InputType(jcoInputType.getSelectedIndex());
        /*Clearing text fields*/
        jtfName.setText("");

        /*Testing existence*/
        File f = new File(ioProvider.getInFile());
        /*Testing existence*/
        String msg = Utils.checkIfHeaderCanBeSet(f);
        if (msg!=null) {
            JOptionPane.showMessageDialog(null, msg,"Unable to set header",JOptionPane.ERROR_MESSAGE);
            return;
        }


        /*Setting header according to conversion type*/
        switch (inputType) {
            case StandardPlaylistItem.IT_BASIC_SOURCE: break;
            case StandardPlaylistItem.IT_BASIC_TOKENIZED: break;
            case StandardPlaylistItem.IT_MONOLITHIC_BINARY: break;
            case StandardPlaylistItem.IT_DATA: break;
            case StandardPlaylistItem.IT_BINARY:  {
                String fn=f.getName();
                if (fn.length()>34) fn=fn.substring(0,34);
                jtfName.setText(fn);
            }
        }


    }//GEN-LAST:event_on_guess_header

    private void onInputTypeChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_onInputTypeChanged

        int inputType = comboIndex2InputType(jcoInputType.getSelectedIndex());
        switch (inputType) {
            case StandardPlaylistItem.IT_MONOLITHIC_BINARY: {
                setPanelEnabled(pHeader,false);
                setPanelEnabled(pBinaryFile,false);
                setPanelEnabled(pOptions,false);
                btnCheckLoader.setEnabled(false);
                seOptionsPanel("cNone");
                break;        
            }
            case StandardPlaylistItem.IT_BINARY: {
                setPanelEnabled(pHeader,true);
                setPanelEnabled(pBinaryFile,true);
                setPanelEnabled(pOptions,false);
                btnCheckLoader.setEnabled(true);
                seOptionsPanel("cNone");
                break;
            }
            case StandardPlaylistItem.IT_DATA: {
                setPanelEnabled(pHeader,false);
                setPanelEnabled(pBinaryFile,false);
                setPanelEnabled(pOptions,true);
                btnCheckLoader.setEnabled(false);
                seOptionsPanel("cPlain");
                break;
            }
            case StandardPlaylistItem.IT_BASIC_TOKENIZED: {
                setPanelEnabled(pHeader,false);
                setPanelEnabled(pBinaryFile,false);
                setPanelEnabled(pOptions,true);
                btnCheckLoader.setEnabled(false);
                seOptionsPanel("cBASIC");
                break;
            }
            case StandardPlaylistItem.IT_BASIC_SOURCE: {
                setPanelEnabled(pHeader,false);
                setPanelEnabled(pBinaryFile,false);
                setPanelEnabled(pOptions,false);
                btnCheckLoader.setEnabled(false);
                seOptionsPanel("cNone");
                break;
            }
        }
        
    }//GEN-LAST:event_onInputTypeChanged

    private void btnCheckLoaderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCheckLoaderActionPerformed

        String message = Utils.checkForBinaryLoader(ioProvider.getInFile(), 0x0804, 0x0965, 0x0804, 0x0965, Integer.MAX_VALUE);
        JOptionPane.showMessageDialog(null, message,"Loader check",JOptionPane.INFORMATION_MESSAGE);

    }//GEN-LAST:event_btnCheckLoaderActionPerformed
    
    private void setPanelEnabled(JPanel p,boolean enabled) {
        p.setEnabled(enabled);
        Component[] comps = p.getComponents();
        for (int i=0;i<comps.length;i++) {
            comps[i].setEnabled(enabled);
        }
    }
    
    private int comboIndex2InputType(int index) {
        switch (index) {
            case 0: return StandardPlaylistItem.IT_MONOLITHIC_BINARY;
            case 1: return StandardPlaylistItem.IT_BINARY;
            case 2: return StandardPlaylistItem.IT_DATA;
            case 3: return StandardPlaylistItem.IT_BASIC_TOKENIZED;
            case 4: return StandardPlaylistItem.IT_BASIC_SOURCE;
            default: return StandardPlaylistItem.IT_MONOLITHIC_BINARY;     
        }
    }
    
    private int InputType2ComboIndex(int inputType) {
        switch (inputType) {
            case StandardPlaylistItem.IT_MONOLITHIC_BINARY: return 0;
            case StandardPlaylistItem.IT_BINARY: return 1;
            case StandardPlaylistItem.IT_DATA: return 2;
            case StandardPlaylistItem.IT_BASIC_TOKENIZED: return 3;
            case StandardPlaylistItem.IT_BASIC_SOURCE: return 4;
            default: return 0;
        }
    }
    
    
    
    
    private void seOptionsPanel(String cardName) {
        CardLayout cl = (CardLayout)pOptions.getLayout();
        cl.show(pOptions, cardName);
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup bgBasic;
    private javax.swing.ButtonGroup bgGaps;
    private javax.swing.JButton btnCheckLoader;
    private javax.swing.JButton btnGuessHeader;
    private javax.swing.JComboBox jcoInputType;
    private javax.swing.JLabel jlbName;
    private javax.swing.JLabel jlbPauses;
    private javax.swing.JRadioButton jrbBootable;
    private javax.swing.JRadioButton jrbCLOAD;
    private javax.swing.JRadioButton jrbLOAD;
    private javax.swing.JRadioButton jrbLongGaps;
    private javax.swing.JRadioButton jrbShortGaps;
    private javax.swing.JTextField jtfName;
    private javax.swing.JPanel pBASICOptions;
    private javax.swing.JPanel pBinaryFile;
    private javax.swing.JPanel pFiller;
    private javax.swing.JPanel pHandling;
    private javax.swing.JPanel pHeader;
    private javax.swing.JPanel pNoOptions;
    private javax.swing.JPanel pOptions;
    private javax.swing.JPanel pPlainOptions;
    private turgen.plugin.SilenceListPanel pSilenceList;
    // End of variables declaration//GEN-END:variables
    
    
    void clear() {
        jtfName.setText("");
        jcoInputType.setSelectedIndex(0);
    }
    
    public StandardPlaylistItem getRecord() {
        
        
        /*Get input type*/
        int inputType = comboIndex2InputType(jcoInputType.getSelectedIndex());
        /*Presume short IRGs (most cases)*/
        int flags = StandardPlaylistItem.CF_SHORTIRG;
        
        switch(inputType) {
            case StandardPlaylistItem.IT_BASIC_SOURCE: {
                flags = StandardPlaylistItem.CF_LONGIRG;
                break;
            }
            case StandardPlaylistItem.IT_DATA: {
                if (jrbLongGaps.isSelected()==true) {
                    flags = StandardPlaylistItem.CF_LONGIRG;
                }
                break;
            }
            case StandardPlaylistItem.IT_BASIC_TOKENIZED: {
                if (jrbLOAD.isSelected()==true) {
                    flags = StandardPlaylistItem.CF_LONGIRG;
                }
                if (jrbBootable.isSelected()==true) {
                    flags |=  StandardPlaylistItem.CF_BOOTBASIC;
                }
                break;
            }
        }
        
        
        StandardPlaylistItem item = new StandardPlaylistItem(ioProvider.getInFile(),
                ioProvider.getOutFile(),
                jtfName.getText(),
                comboIndex2InputType(jcoInputType.getSelectedIndex()),
                Utils.parseSilenceList(pSilenceList.getSilenceListString().trim()),
                flags,
                ioProvider.getPulses()
        );
        return item;
    }

    
    public void fill(StandardPlaylistItem item) {
        jtfName.setText(item.fname);
        jcoInputType.setSelectedIndex(InputType2ComboIndex(item.inputType));
        pSilenceList.setSilenceListString(Utils.silenceListToString(item.silenceList));
        
        if ((item.conversionFlags & StandardPlaylistItem.CF_LONGIRG) == StandardPlaylistItem.CF_LONGIRG) {
            jrbLOAD.setSelected(true);
            jrbLongGaps.setSelected(true);
        }
        else {
            jrbCLOAD.setSelected(true);
            jrbShortGaps.setSelected(true);
        }
        if ((item.conversionFlags & StandardPlaylistItem.CF_BOOTBASIC) == StandardPlaylistItem.CF_BOOTBASIC) {
            jrbBootable.setSelected(true);
        }
     
    

    }
    
    public String verify() {
        int inputType = comboIndex2InputType(jcoInputType.getSelectedIndex());
        switch(inputType) {
            case StandardPlaylistItem.IT_MONOLITHIC_BINARY: {
                
                try {
                    DOS2Binary binary = new DOS2Binary(ioProvider.getInFile());
                    return plugin.verifyMonolithicBinary(null, binary);
                }
                catch(Exception e) {
                    return "Unable to verify playlist item: "+Utils.getExceptionMessage(e);
                }
                
            }
            default: return null;
        }
    }
    
    
    private void setupToolTips() {
        
    }
    
    public void setIOProvider(InOutProvider provider) {
        ioProvider=provider;
        pSilenceList.setIOProvider(provider);
    }


}


   



